package org.jbox2d.callbacks;

import org.jbox2d.dynamics.Fixture;
import org.jbox2d.dynamics.joints.Joint;

import anywheresoftware.b4a.BA;

@BA.Hide
public class DestructionListenerB4A implements DestructionListener
{
	private String m_GoodbyeJoint = "";
	private String m_GoodbyeFixture = "";
	private BA m_Ba;

	public DestructionListenerB4A(final BA ba, final String GoodbyeJointSub, final String GoodbyeFixtureSub)
	{
		m_GoodbyeJoint = GoodbyeJointSub.toLowerCase(BA.cul);
		m_GoodbyeFixture = GoodbyeFixtureSub.toLowerCase(BA.cul);
		m_Ba = ba; 
	}

	@Override
	public void sayGoodbye(Joint joint) {
		if  (!m_GoodbyeJoint.equals(""))
			m_Ba.raiseEvent2(this, false, m_GoodbyeJoint, true, new Object[] { joint });
	}

	@Override
	public void sayGoodbye(Fixture fixture) {
		if  (!m_GoodbyeFixture.equals(""))
			m_Ba.raiseEvent2(this, false, m_GoodbyeFixture, true, new Object[] { fixture });
	}
}