package org.jbox2d.callbacks;

import org.jbox2d.dynamics.Fixture;

import anywheresoftware.b4a.BA;

@BA.ShortName("jbQueryCallback")
@BA.Events(values = {
		"ReportFixture(Fixture As jbFixture) As Boolean" 
})
public class QueryCallbackB4A implements QueryCallback
{
	private String m_CallbackSub = "";
	private BA m_Ba;

	/**
	 * Register a query callback function.
	 * This callback function will be called by jbWorld.queryAABB.
	 */
	public void Initialize(final BA ba, final String CallbackSub)
	{
		m_CallbackSub = CallbackSub.toLowerCase(BA.cul);
		m_Ba = ba; 
	}

	@BA.Hide
	@Override
	public boolean reportFixture(Fixture fixture) {
		if  (m_CallbackSub.equals(""))
			return false;
		else
			return (Boolean) m_Ba.raiseEvent2(this, false, m_CallbackSub, true, new Object[] { fixture });
	}
}