package org.jbox2d.callbacks;

import org.jbox2d.common.Vec2;
import org.jbox2d.dynamics.Fixture;

import anywheresoftware.b4a.BA;

@BA.ShortName("jbRayCastCallback")
@BA.Events(values = {
		"ReportFixture(Fixture As jbFixture, Point As jbVec2, Normal As jbVec2, Fraction As Float) As Float" 
})
public class RayCastCallbackB4A implements RayCastCallback
{
	private String m_CallbackSub = "";
	private BA m_Ba;

	/**
	 * Register a raycast callback function.
	 * This callback function will be called by jbWorld.raycast.
	 */
	public void Initialize(final BA ba, final String CallbackSub)
	{
		m_CallbackSub = CallbackSub.toLowerCase(BA.cul);
		m_Ba = ba; 
	}

	@BA.Hide
	@Override
	public float reportFixture(Fixture fixture, Vec2 point, Vec2 normal, float fraction) {
		if  (m_CallbackSub.equals(""))
			return 0;
		else
			return (Float) m_Ba.raiseEvent2(this, false, m_CallbackSub, true, new Object[] { fixture, point, normal, fraction });
	}
}