package org.jbox2d.callbacks;

import anywheresoftware.b4a.BA;

@BA.ShortName("jbTreeCallback")
@BA.Events(values = {
		"TreeCallback(ProxyId As Int) As Boolean" 
})
public class TreeCallbackB4A implements TreeCallback
{
	private String m_CallbackSub = "";
	private BA m_Ba;

	/**
	 * Register a tree callback function.
	 * This callback function will be called by jbDynamicTree.query.
	 */
	public void Initialize(final BA ba, final String CallbackSub)
	{
		m_CallbackSub = CallbackSub.toLowerCase(BA.cul);
		m_Ba = ba; 
	}

	@BA.Hide
	@Override
	public boolean treeCallback(int proxyId) {
		if  (m_CallbackSub.equals(""))
			return false;
		else
			return (Boolean) m_Ba.raiseEvent2(this, false, m_CallbackSub, true, new Object[] { proxyId });
	}
}