package org.jbox2d.callbacks;

import org.jbox2d.collision.RayCastInput;

import anywheresoftware.b4a.BA;

@BA.ShortName("jbTreeRayCastCallback")
@BA.Events(values = {
		"RayCastCallback(Input As jbRayCastInput, NodeId As Int) As Float" 
})
public class TreeRayCastCallbackB4A implements TreeRayCastCallback
{
	private String m_CallbackSub = "";
	private BA m_Ba;

	/**
	 * Register a raycast callback function.
	 * This callback function will be called by jbDynamicTree.raycast.
	 */
	public void Initialize(final BA ba, final String CallbackSub)
	{
		m_CallbackSub = CallbackSub.toLowerCase(BA.cul);
		m_Ba = ba; 
	}

	@BA.Hide
	@Override
	public float raycastCallback(RayCastInput input, int nodeId) {
		if  (m_CallbackSub.equals(""))
			return 0;
		else
			return (Float) m_Ba.raiseEvent2(this, false, m_CallbackSub, true, new Object[] { input, nodeId });
	}
}